package uu.binf.utils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.*;

import cern.colt.list.IntArrayList;
import cern.jet.random.engine.MersenneTwister;

public class ListUtils {
	
	public static int getMin(IntArrayList l){
		int min = 999999999;
		for(int i = 0;  i < l.size(); i++){
			if(l.get(i) < min){
				min = l.get(i);
			}
		}
		return min;
	}
	
	//complement
	public static Vector complement(List l0, List l1) {
		Set complement = new HashSet();
		for (int i = 0; i < l0.size(); i++) {
			if(!l1.contains(l0.get(i))){
				complement.add(l0.get(i));
			}
		}
		for (int i = 0; i < l1.size(); i++) {
			if(!l0.contains(l1.get(i))){
				complement.add(l1.get(i));
			}
		}
		return new Vector(Arrays.asList(complement.toArray()));
	}
	
	//finds whether the intersection is null or not
	public static boolean intersect(List l0, List l1) {
		for (int i = 0; i < l0.size(); i++) {
			for (int j = 0; j < l1.size(); j++) {
				if (l0.get(i).equals(l1.get(j))) {
					return true;
				}
			}
		}
		return false;
	}
	
	public static List getIntersection(List l0, List l1) {
		ArrayList inter = new ArrayList();
		for (int i = 0; i < l0.size(); i++) {
			if(l1.contains(l0.get(i))){
				inter.add(l0.get(i));
			}
		}
		return inter;
	}
	
	public static int sizeIntersection(List l0, List l1) {
		int size = 0;
		for (int i = 0; i < l0.size(); i++) {
			if(l1.contains(l0.get(i))){
				size++;
			}
		}
		return size;
	}
	
	public static Set getUnion(Set l0, List l1) {
		HashSet union = new HashSet();
		union.addAll(l0);
		union.addAll(l1);
		return union;
	}
		
	public static List isSubset(List l0, List l1){
		List subset = l0, superset = l1;
		if(l1.size() < l0.size()){
			subset = l1;
			superset = l0;
		}
		boolean flag;
		for (int i = 0; i < subset.size(); i++) {
			flag = false;
			for (int j = 0; j < superset.size(); j++) {
				if (!subset.get(i).equals(superset.get(j))) {
					flag = true;
					break;
				}
			}
			if(flag){
				return null;
			}
		}
		return superset;
	}
	
	public static int getSizeIntersection(Collection c1, Collection c2) {
		int sum = 0;
		for (Iterator i = c1.iterator(); i.hasNext();) {
			if (c2.contains(i.next())) {
				sum++;
			}
		}
		return sum;
	}
	
	public static List readList(String file) throws Exception{
		String l;
		BufferedReader r = new BufferedReader(new FileReader(file));
		List list = new ArrayList();
		while((l = r.readLine())!=null){
			if(l.startsWith("#"))
				continue;
			list.add(l);
		}
		r.close();
		return list;
	}
	
	public static List readList(String file, int idx, String sep) throws Exception{
		String l;
		BufferedReader r = new BufferedReader(new FileReader(file));
		List list = new ArrayList();
		while((l = r.readLine())!=null){
			if(l.startsWith("#"))
				continue;
			String [] splitted = l.split(sep);
			if(splitted.length <= idx)
				continue;
			else list.add(splitted[idx]);
		}
		r.close();
		return list;
	}
	
	public static void randomize(List list, MersenneTwister mt){
		for(int i = 0; i < list.size()-1; i++){
			Object elem1 = list.get(i);
			int idx = mt.choose(i+1,list.size()-1);
			Object elem2 = list.get(idx);
			list.set(i,elem2);
			list.set(idx,elem1);
		}
	}
}
